package risk.lobby.client;

import org.lobby.client.*;
import risk.ui.FlashGUI.FlashRiskAdapter;
import risk.ui.FlashGUI.GameFrame;

import risk.engine.*;

import risk.engine.core.*;

import java.awt.Frame;
import java.awt.Dimension;
import java.util.Map;
import java.util.HashMap;
import javax.swing.JDialog;
import java.net.URL;

import java.applet.Applet;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.BorderFactory;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.BorderLayout;
import java.util.ResourceBundle;
import java.util.Vector;

public class ClientGameRisk extends TurnBasedAdapter {

	private final static String product = "Risk Lobby Client";
	private final static String version = "0.1";


	public ClientGameRisk() { }


	//##################################################################################
	// game setup
	//##################################################################################

	private String newGameOptions;

	private String mapsurl;
	private RiskMap[] maps;

	private JDialog dialog;
	private GameSetupPanel gsp;

	private HashMap MapMap;

	public String getGameName() {

		return "Risk";

	}

	public GameSetup newGameDialog(Frame parent, String serveroptions,String myname) { // String serveroptions is a list of maps

		if (serveroptions!=null && !serveroptions.equals(newGameOptions) ) {

			newGameOptions = serveroptions;

			dialog = new JDialog(parent,"Loading...",true);
			final JLabel loadingmap = new JLabel("Loading:", JLabel.CENTER);

			//loadingmap.setVerticalTextPosition(JLabel.TOP);
			//loadingmap.setHorizontalTextPosition(JLabel.CENTER);

			loadingmap.setHorizontalTextPosition(JLabel.LEFT);

			dialog.getContentPane().add(loadingmap);
			dialog.setSize(100,100);
			dialog.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);

			new Thread() {

			    public void run() {

				//String[] split = newGameOptions.split("\\n");

				String[] split = newGameOptions.split(",");

				maps = new RiskMap[split.length];
				//int[] tries = new int[split.length];

				for (int c=0;c<split.length;c++) {

					//tries[c]++;

					//String mapinfo[] = split[c].split("\\ ");

					//String displayName = split[c].substring(mapinfo[0].length() + mapinfo[1].length() + 2 , split[c].length() );

					maps[c] = getRiskMap(split[c]);

					loadingmap.setIcon( maps[c].getIcon() );

				}
				JDialog d = dialog;
				dialog = null;

				d.setVisible(false);
				d.dispose();

			    }
			}.start();

			dialog.setVisible(true);


		}

		if (dialog == null) {


			dialog = new JDialog(parent,"Game Options",true);

			gsp = new GameSetupPanel(maps,dialog,myname+"'s "+getGameName()+" Game");

			// @todo:
			// do noting on close
			// when close then send event to gsp

			dialog.setContentPane(gsp);
			dialog.setResizable(false);
			dialog.pack();

		}

		gsp.reset();

		dialog.setVisible(true);

		String op = gsp.getOptions();

		if (op!=null) { return new GameSetup( gsp.getGameName(), op, gsp.getNumberOfHumanPlayers() ); }

		return null;

	}

	public ImageIcon getIcon(String options) {

		String choosemap = options.split("\\n")[3];

		return getRiskMap( choosemap.substring( 10 ,choosemap.length() ) ).getSmallIcon();

	}

	public RiskMap getRiskMap(String name) {

		Risk.setupMapsDir(applet);

		if (MapMap==null) { MapMap = new HashMap(); }


		RiskMap themap = (RiskMap)MapMap.get(name);

		if (themap==null) {

		    for (int c=0;true;c++) {

			try {

				themap = new RiskMap( Risk.mapsdir, name );
				break;

			}
			catch(Exception ex) {

				ex.printStackTrace();

				if (c < 5) { // retry

					//c--;
					try { Thread.sleep(1000); } catch(Exception ex2) { }
				}
				else { // give up

					themap = new RiskMap(name);
					break;
				}


			}

		    }

		    MapMap.put(name,themap);

		}

		return themap;

	}

	//##################################################################################
	// in game client stuff
	//##################################################################################





	private static ResourceBundle resb = risk.engine.translation.TranslationBundle.getBundle();


	private ClientRisk myrisk;




	//private boolean stopflag;


	private JLabel nameLabel;

	private GameFrame frame;


	public void startNewGame(String name) {

		if (frame==null) {


			myrisk = new ClientRisk(applet,this);

			makeNewGameFrame();

		}

		nameLabel.setText(name);

	}

	private void makeNewGameFrame() {

		resb = risk.engine.translation.TranslationBundle.getBundle();

		//setReplay(false);

		final Box sidepanel = new Box(javax.swing.BoxLayout.Y_AXIS);




		JButton aboutButton = new JButton( resb.getString( "mainmenu.about") );

		aboutButton.addActionListener( new ActionListener() {

			public void actionPerformed(ActionEvent ae) {

				Risk.openAbout(frame,product, version);

			}

		});


		JPanel panel1 = new JPanel();
		JPanel panel2 = new JPanel();
		JPanel panel3 = new JPanel();



		nameLabel = new JLabel();

		panel1.add( nameLabel );
		panel2.add( timer );
		panel3.add( startButton );
		panel3.add( aboutButton );

		sidepanel.add( panel1 );
		sidepanel.add( panel2 );
		sidepanel.add( playerListArea );
		sidepanel.add( panel3 );
		sidepanel.add( chatBoxArea );

		ImageIcon borderimage = new ImageIcon( ClientGameRisk.class.getResource("back.jpg") );

		panel2.setBorder( BorderFactory.createMatteBorder(20, 0, 20, 0, borderimage ) );
		panel3.setBorder( BorderFactory.createMatteBorder(20, 0, 20, 0, borderimage ) );
		sidepanel.setBorder( BorderFactory.createMatteBorder(20, 20, 20, 20, borderimage ) );

		Dimension topsize = new Dimension(160,120);

		playerListArea.setPreferredSize( topsize );
		playerListArea.setMaximumSize( topsize );
		playerListArea.setMinimumSize( topsize );

		sidepanel.setPreferredSize( new Dimension(200,600) );



		FlashRiskAdapter riskadapter = new FlashRiskAdapter(myrisk) {

			public void addPlayer(int type, String name, java.awt.Color color, String ip) {}
			public void sendDebug(String a) {  } // System.out.println("\tRISK "+ a);

			public void noInput() {

				if (gameFrame!=null) {
					gameFrame.noInput();
				}
			}

			public void startGame(boolean s) {

				try {
					pp.load();
				}
				catch (Exception e) {
					e.printStackTrace();
				}

				gameFrame.setup(s);

				gameFrame.setVisible(true);
				gameFrame.requestFocus();

			}

			public void closeGame() {

				gameFrame.setVisible(false);

			}

			//public void needInput(int s) {
			//	super.needInput(s);
			//}

		};




		frame = riskadapter.getGameFrame();

		frame.getContentPane().add(sidepanel, java.awt.BorderLayout.EAST );
		frame.pack();




		// amoung other things, the newplayer command needs to be passed with option that matches this
		// computers Risk.myAddress, or the Risk game would not know when to ask for input



	}

	// this NEEDS to call leaveGame();
	public void closegame() {

		myrisk.parser("closegame");

	}

	// amount other things this locks the interface from input and sets needinput to false
	public void resignPlayer() {

		frame.blockInput();
		myrisk.resignPlayer();
	}

	public void blockInput() {

		frame.blockInput();

	}

	public void gameString(String message) {

		System.out.println("\tGOT: "+message);

		myrisk.addToInbox(message);

	}


	public void gameObject(Object object) {


		Object[] objects = (Object[])object;

		myrisk.createGame( (String)objects[0] , (RiskGame)objects[1] );

		// not needed as "gameFrame.setup(s);" calls this anyway
		//frame.setGameStatus(null);

	}



/*
	public static void main(String[] argv) throws Exception { // TESTING METHOD!!!!


		// server sends
		// GameId = 1
		// GameName = Risk // maybe NOT
		// JarFile = Risk.jar // or a full URL
		// LobbyGame = risk.lobby.LobbyGameRisk
		// gameOptions = list of maps that can be used

		// create a new LobbyGame

		String name = "risk.lobby.LobbyGameRisk";
		Class myclass = Class.forName( name );
		LobbyGame lobbygame = (LobbyGame)myclass.newInstance();
		lobbygame.addLobbyGameMoveListener( new LobbyGameMoveListener() );

		//selected gametype Risk
		// clicked new game
		// need to make a new game string
		String newGameOptionString = lobbygame.newGameDialog( null , 

			"http://jrisk.sourceforge.net/applet/maps/\n"+
			"http://jrisk.sourceforge.net/images/maps/\n"+
			"board.map aa.jpg Risk Board\n" +
			"board.map board.jpg Risk Board\n" +
		//	"board.map chutes.jpg Risk Board\n" +
		//	"board.map conquest.jpg Risk Board\n" +
		//	"board.map cow.jpg Risk Board\n" +
		//	"board.map europass.jpg Risk Board\n" +
		//	"board.map fortress.jpg Risk Board\n" +
		//	"board.map france.jpg Risk Board\n" +
		//	"board.map geoscape.jpg Risk Board\n" +
			"risk2.map risk2.jpg Risk II"


		); // getParent

		System.out.println("GOT START GAME OPTIONS: "+newGameOptionString);



		// send it to the server

		// sever informs lobbs that new game is made

		// people can join

		// player who made it is autojoined and the game is removed from the list if everyone leaves

		// lobby sends...


		// game starts when it fills up
//		lobbygame.joinGame(game_id_from_server , newGameOptionString + playerinfo);

		// Risk object is onyl now created
		// options are passed to it
		// game starts



		// spectator comes in

	}
*/
}
